#include "oop.h"
#include "minmax.h"

oop Collection::classNew(int size)
{
  subclassResponsibility(0);
}

oop Collection::errorEmptyCollection(void)
{
  return error("this collection is empty");
}

oop Collection::errorSubscriptBounds(int index)
{
  return error("subscript is out of bounds: %d", index);
}

oop Collection::emptyCheck(void)
{
  if (isEmpty())
    errorEmptyCollection();
  return this;
}

int Collection::isEmpty(void)
{
  return !size();
}

int Collection::notEmpty(void)
{
  return !isEmpty();
}

oop Collection::asArray(void)
{
  oop array= new Array(size());
  int i= 0;
  iterate(this, iter)
    array->atPut(i++, iter.element());
  return array;
}

oop Collection::addAll(oop aCollection)
{
  iterate(aCollection, iter)
    add(iter.element());
  return aCollection;
}

int Collection::includes(oop anObject)
{
  iterate(this, iter)
    if (*iter.element() == anObject)
      return 1;
  return 0;
}

oop Collection::printOn(oop aStream)
{
  int first= 1;
  aStream->format("%s(", _debugName());
  iterate(this, iter)
    {
      if (first)
	first= 0;
      else
	aStream->space();
      iter.element()->printOn(aStream);
    }
  aStream->format(")");
  return this;
}

oop Collection::asSortedCollection(int (*block)(oop x, oop y))
{
  oop sc= new SortedCollection(size());
  sc->sortBlock(block);
  sc->addAll(this);
  return sc;
}

oop Collection::asSortedCollection(void)
{
  return asSortedCollection(0);
}
